from flask import Flask , render_template, request
from keras.models import load_model
from tensorflow import keras
from keras.preprocessing import image
import numpy as np



app = Flask(__name__)

dic = {0 : 'Healthy', 1 : 'Sigatoka'}

model = load_model('diseases_model.h5')

model.make_predict_function()


def predict_label(img_path):
    i = image.load_img(img_path, target_size = (100,100))
    i = image.img_to_array(i)/255.0
    i = i.reshape(1, 100, 100, 3)
    
    #p = model.predict_classes(i)

    predict_x=model.predict(i) 
    p=np.argmax(predict_x,axis=1)

    return dic[p[0]]
 
@app.route("/", methods=['GET', 'POST'])
def home(): 
    return render_template("index.html")

@app.route("/submit",  methods = ['GET', 'POST'])
def predict():
    if request.method == 'POST':
        img = request.files['my_image']

        img_path = "images/" + img.filename
        img.save(img_path)

        p = predict_label(img_path)   

    return render_template("index.html", prediction = p, img_path = img_path)



if __name__ == "__main__":
    app.run(debug=True)


# @app.route("/sub",  methods = ["POST"])
# def submit():
#    if request.method == "POST":
#        name = request.form["username"]
#    return render_template("sub.html" , n = name )


